*
* Bill Palmer
*
* (c) 1987, François Coulon
* (c) 2021, Brutal Deluxe
*

         lst   off
         rel
         dsk   ace.l

         mx    %00
         xc
         xc

*--------------------------------------

	use	4/ACE.Macs
	use	4/Locator.Macs
	use	4/Mem.Macs
	use	4/Misc.Macs
	use	4/Sound.Macs
	use	4/Util.Macs

*--------------------------------------

Debut    =     $00
Arrivee  =     $04
Second   =     $08
Third    =     $0c

proDOS   =     $e100a8

*--------------------------------------

	phk
	plb

	clc
	xce
	rep	#$30

        _TLStartUp
        pha
        _MMStartUp
        pla
        sta	myID
        _MTStartUp

*--------------------------------------

okINIT1
         PushLong #0
         PushLong #$8fffff
         PushWord myID
         PushWord #%11000000_00000000
         PushLong #0
         _NewHandle
         _DisposeHandle
         _CompactMem

*--------------------------------------

         PushLong #0
         PushLong #$40000
         PushWord myID
         PushWord #%11000000_00001100
         PushLong #0
         _NewHandle
         phd
         tsc
         tcd
         lda   [3]
         sta   ptrSOURCE
         ldy   #2
         lda   [3],y
         sta   ptrSOURCE+2
         pld
         pla
	 sta	haSOURCE
	 pla
	 sta	haSOURCE+2
	 
         PushLong #0
         PushLong #$20000
         PushWord myID
         PushWord #%11000000_00001110
         PushLong #0
         _NewHandle
         phd
         tsc
         tcd
         lda   [3]
         sta   ptrDEST
         ldy   #2
         lda   [3],y
         sta   ptrDEST+2
         pld
         pla
	 sta	haDEST
	 pla
	 sta	haDEST+2
	
*-------------------------------------- Load file
	
	lda	#pSAMPLE
	ldx	ptrSOURCE+2
	ldy	ptrSOURCE
	jsr	loadFILE
	
*-------------------------------------- Compress data

	PushWord #29	; Load ACE
	PushWord #0
	_LoadOneTool
	
	tdc
	clc
	adc	#$100
	pha
	_ACEStartUp
	
	_ACECompBegin
	
	PushLong haSOURCE
	PushLong #0
	PushLong haDEST
	PushLong #0
	PushWord #488
	PushWord #1
	_ACECompress
	
*---

	sep	#$20
]lp	ldal	$c000
	bpl	]lp
	stal	$c010
	rep	#$20
	
*-------------------------------------- Save file

	lda	#$e800
	sta	proREAD+8
	lda	#$0001
	sta	proREAD+10

	lda	#pSAMPLE2
	ldx	ptrDEST+2
	ldy	ptrDEST
	jsr	saveFILE

*--------------------------------------

	_ACEShutDown
	
	PushWord #29
	_UnloadOneTool
	
*--------------------------------------

initOFF
	_MTShutDown

	PushWord myID
	_DisposeAll
	PushWord myID
	_MMShutDown
	_TLShutDown

	jsl	proDOS
	dw	$2029
	adrl	proQUIT

	brk	$bd

*--------------------------------------

loadFILE
	sta	proOPEN+4
	sty	proREAD+4
	stx	proREAD+6

	jsl	proDOS
	dw	$2010
	adrl	proOPEN

	lda	proOPEN+2
	sta	proGETEOF+2
	sta	proREAD+2
	sta	proCLOSE+2

	jsl	proDOS
	dw	$2019
	adrl	proGETEOF

	lda	proGETEOF+4
	sta	proREAD+8
	lda	proGETEOF+6
	sta	proREAD+10

	jsl	proDOS
	dw	$2012
	adrl	proREAD
	
	jsl	proDOS
	dw	$2014
	adrl	proCLOSE
	rts

*--------------------------------------

saveFILE
	sta	proOPEN+4
	sty	proREAD+4
	stx	proREAD+6

	jsl	proDOS
	dw	$2010
	adrl	proOPEN

	lda	proOPEN+2
	sta	proREAD+2
	sta	proCLOSE+2

	jsl	proDOS
	dw	$2013	; it is WRITE
	adrl	proREAD
	
	jsl	proDOS
	dw	$2014
	adrl	proCLOSE
	rts

*--------------------------------------
* All the data
*--------------------------------------

*--- Prodos

proQUIT  dw    2
         ds    4
         ds    2

proOPEN  dw    2
         ds    2
         adrl  pSAMPLE

proGETEOF dw   2
         ds    2
         ds    4

proREAD  dw    4
         ds    2
         ds    4
         ds    4
         ds    4

proCLOSE dw    1
         ds    2

*--- Nom des fichiers

pSAMPLE	strl	'1/Data/Sample'
pSAMPLE2	strl	'1/Data/Sample2'

*--- Flags

*--- Memoire

myID	ds	2

haSOURCE	ds	4
ptrSOURCE	ds	4
haDEST	ds	4
ptrDEST	ds	4
